Subject: Re: S3 sleep no longer works on x86_64 in 2.6.27

From: "H. Peter Anvin" <[email-masked]>
Date: Thu, 23 Oct 2008 19:44:39 -0700

Ingo Molnar wrote:
> * Gleb Natapov <[email-masked]> wrote:
> 
>> Hi,
>>
>> S3 sleep no longer works on x86_64 (at least in KVM, but it looks like 
>> this is the kernel bug). Kernel 2.6.26 works. I think that the commit 
>> that caused the problem is a939098af, but I can't be 100% sure since 
>> compilation is broken at this point.
>>
>> Triple fault happens during S3 resume. It happens in 
>> arch/x86/kernel/head_64.S during access to GDT after it was loaded on 
>> line 213 (lgdt early_gdt_descr(%rip)) early_gdt_descr points to 
>> per_cpu__gdt_page and this address contains valid GDT entries during a 
>> regular boot, but on S3 resume in contains garbage. It seems that 
>> per_cpu area is reallocated somewhere, but I don't understand this 
>> magic enough to fix it. Can somebody look at this and explain what 
>> happens?
> 
> could you check whether the (post-v2.6.27) upstream fix below does the 
> trick for you?
> 
> 	Ingo
> 
> From 3038edabf48f01421c621cb77a712b446d3a5d67 Mon Sep 17 00:00:00 2001
> From: Rafael J. Wysocki <[email-masked]>
> Date: Fri, 17 Oct 2008 01:26:27 +0200
> Subject: [PATCH] x86 ACPI: fix breakage of resume on 64-bit UP systems with SMP kernel
> 
> x86 ACPI: Fix breakage of resume on 64-bit UP systems with SMP kernel
> 

Is this patch scheduled for 2.6.27-stable?  If not, it sounds like it 
should be.

	-hpa